#include "stdlib.h"
#include "fxlib.h"
#include "revolution.h"

unsigned char* VRam_Base(); //syscall servant a obtenir l'adresse de la VRAM, quelque soit l'OS

char *buffer1, *buffer2, *bufferVRAM1, *bufferVRAM2;

void clearDD()
{
	memset(buffer1, 0, 1024);
	memset(buffer2, 0, 1024);
}

void clearVRAM()
{
	memset(bufferVRAM1, 0, 1024);
	memset(bufferVRAM2, 0, 1024);
}

void SwapBuffers()
{
	char* temp;
	temp = buffer1;
	buffer1 = bufferVRAM1;
	bufferVRAM1 = temp;

	temp = buffer2;
	buffer2 = bufferVRAM2;
	bufferVRAM2 = temp;

	GrayLinkBuffers(buffer1, buffer2);
}

void SL_DrawSprite8(unsigned char *sprite1, unsigned char *sprite2, unsigned char *cache, char *buffer1, char *buffer2, int x, int y)
{
    unsigned short ligne;
    char i, decalage, debut = 0, fin = 8, *ecran, *adresseLigne = (char*)&ligne;

    if(x < -8 || x > 127) return;
    decalage = 8 - x%8;
    x /= 8;

    //if sprite is on limits of screen
    if(y < 0) debut = -y;
    if(y > 56) fin -= y-56;

    //cache for white color
    if(cache)
    {
        ecran = (void*)(buffer1 + 16*(y+debut) + x);
        for(i=debut ; i<fin ; i++)
        {
            ligne = ~(cache[i] << decalage);
            ecran[0] &= adresseLigne[0];
            ecran[1] &= adresseLigne[1];
            ecran += 16;
        }
    }

    ecran = (void*)(buffer1 + 16*(y+debut) + x);
    for(i=debut ; i<fin ; i++)
    {
        ligne = sprite1[i] << decalage;
        ecran[0] |= adresseLigne[0];
        ecran[1] |= adresseLigne[1];
        ecran += 16;
    }

    //buffer2 for grayscales
    if(buffer2)
    {
        if(cache)
        {
            ecran = (void*)(buffer2 + 16*(y+debut) + x);
            for(i=debut ; i<fin ; i++)
            {
                ligne = ~(cache[i] << decalage);
                ecran[0] &= adresseLigne[0];
                ecran[1] &= adresseLigne[1];
                ecran += 16;
            }
        }
        if(!sprite2) sprite2 = sprite1;
        ecran = (void*)(buffer2 + 16*(y+debut) + x);
        for(i=debut ; i<fin ; i++)
        {
            ligne = sprite2[i] << decalage;
            ecran[0] |= adresseLigne[0];
            ecran[1] |= adresseLigne[1];
            ecran += 16;
        }
    }
}

char* int2str(char* c, int n)
{
    if(n==0)
    {
        c[0] = '0';
        c[1] = 0;
    }
    else
    {
        int i, l=0;
        for(i=n ; i ; i/=10)
            l++;
        c[l] = 0;
        for(i=n ; i ; i/=10)
            c[--l] = i%10+'0';
    }
    return c;
}

int jeu()
{

	//sprites:
	char milieu1[] = {255,0,136,17,34,68,255,255};
	char milieu2[] = {255,0,221,187,119,238,255,255};
	char milieu3[] = {0,255,119,238,221,187,0,0};

	char gauche1[] = {63,64,136,145,162,132,127,63};
	char gauche2[] = {127,192,157,187,183,238,255,127};
	char gauche3[] = {192,191,119,110,93,123,128,192};

	char droite1[] = {252,2,139,19,35,71,254,252};
	char droite2[] = {254,3,223,187,119,239,255,254};
	char droite3[] = {3,253,116,236,220,184,1,3};

	char cercle1[] = {60,66,139,147,163,135,126,60};
	char cercle2[] = {126,195,159,187,183,239,255,126};
	char cercle3[] = {195,189,116,108,92,120,129,195};

	char balle1[] = {60,70,131,131,131,199,126,60};
	char balle2[] = {60,94,143,223,255,255,126,60};
	char balle3[] = {0,56,124,124,124,56,0,0};

	char map[16][9]={0}, decalage=0;
	int i, j, k, y, score=0, vitesse = 200000;
	int ballX=60, ballY=2, ballDX, ballDY;

	clearDD();
	clearVRAM();

	GrayLinkBuffers(buffer1, buffer2);
	GrayInit(3273, 1452);

	while(ballY!=decalage)
	{
		if(FastKeyDown(K_EXIT)) return 0;
		score++;

		//dcalage de la map
		decalage++;
		if(decalage%24 == 0)
		{
			y = (decalage/8+8)%9;
			map[0][y] = 2; //initialisation de la ligne
			for(i=1 ; i<15 ; i++)
				map[i][y] = 1;
			map[15][y] = 3;
			k = j = 0;
			for(i=0 ; i<2 ; i++) //2 trous par ligne
			{
				while(j==k) j = rand()%13;
				k=j; //pour que les 2 trous ne soient pas au mme endroit
				if(map[j][y]) map[j][y] += 2; //bordure droite, a gauche du trou
				map[j+1][y] = 0;
				map[j+2][y] = 0;
				if(map[j+3][y]) map[j+3][y] += 1; //bordure gauche, a droite du trou
			}

			if(decalage == 9*8)
				decalage = 0;
		}

		//mouvements de la balle
		ballDX=0;
		ballDY = 2; //on fait tomber la balle
		if((ballY-decalage+72)%72 == 55) ballDY=1; //si la balle est tout en bas
		switch(map[ballX/8][(ballY/8+1)%9]) //s'il y a un mur en dessous
		{
			case 3:
			case 4: ballDX=1; //si on est sur le bord d'un trou on glisse vers lui
			case 1:
			case 2: ballDY=0;
					ballY = ballY/8*8;
		}
		if(ballX%8)
		{
			switch(map[ballX/8+1][(ballY/8+1)%9])
			{
				case 2:
				case 4: ballDX=-1;
				case 1:
				case 3: ballDY=0;
						ballY = ballY/8*8;
			}
		}
		if(FastKeyDown(K_LEFT)) ballDX = -2;
		if(FastKeyDown(K_RIGHT)) ballDX = 2;

		if(ballDX==-2 && ballX%8==0 && ballY%8) //on vrifie si on ne touche pas un mur sur le cot
		{
			if(map[ballX/8-1][ballY/8] || map[ballX/8-1][(ballY/8+1)%9])
				ballDX = 0;
		}
		if(ballDX==2 && ballX%8==0 && ballY%8)
		{
			if(map[ballX/8+1][ballY/8] || map[ballX/8+1][(ballY/8+1)%9])
				ballDX = 0;
		}
		ballX += ballDX;
		if(ballX<0) ballX=0;
		if(ballX>120) ballX=120;
		ballY = (ballY+ballDY)%72;

		//affichage
		clearVRAM();
		for(j=2 ; j<9 ; j+=3)
		{
			y = j*8-decalage;
			if(y<-8) y+=72;
			for(i=0 ; i<16 ; i++)
			{
				switch(map[i][j])
				{
					case 1:
						SL_DrawSprite8(milieu1, milieu2, milieu3, bufferVRAM1, bufferVRAM2, i*8, y);
						break;
					case 2:
						SL_DrawSprite8(gauche1, gauche2, gauche3, bufferVRAM1, bufferVRAM2, i*8, y);
						break;
					case 3:
						SL_DrawSprite8(droite1, droite2, droite3, bufferVRAM1, bufferVRAM2, i*8, y);
						break;
					case 4:
						SL_DrawSprite8(cercle1, cercle2, cercle3, bufferVRAM1, bufferVRAM2, i*8, y);
						break;
				}
			}
			y = ballY-decalage;
			if(y<-8) y+=72;
			SL_DrawSprite8(balle1, balle2, balle3, bufferVRAM1, bufferVRAM2, ballX, y);
		}
		SwapBuffers();
		for(i=0 ; i<vitesse ; i++);
		if(vitesse>150000) vitesse-=200; //on fait acclrer le jeu graduellement
		if(vitesse>100000) vitesse-=50;
		if(vitesse>50000) vitesse-=10;
	}
	GrayEnd();
	return score;
}

void titre()
{
	unsigned long buffer1[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0x001FFFF0,0x001F9FE0,0x3FFC0000,0,0x000E7C60,0x0018DCC0,0x38FC0000,0,0x0005E7E0,0x001F8BC0,0x1ECE0000,0,0x00056760,0x001F0AC0,0x1F8F0000,0,0x0007C3C0,0x00359F80,0x158B0000,0,0x000A86C0,0x003F1700,0x3F1B0000,0,0x001A86C0,0x002A1D80,0x3F0F0000,0,0x000F8780,0x002A3F00,0x2B160000,0,0x00150700,0x007E6A00,0x7E320000,0,0x00350380,0x00D67A00,0x7E3B0000,0,0x001F270F,0xF07C5E00,0x562A1F0F,0xFFF7DFF8,0x002A767F,0x30FCD600,0x7C6E3F8C,0xFCE799E4,0x007AE6FB,0x51ACF400,0xF87C7F45,0xCDC7B5EE,0x007EE4F3,0x51F8BC00,0xAC56D367,0xC7C63D7E,0x0057E099,0x71F1AC00,0xF8DC9A6F,0x8F863F7E,0x00F5C15B,0xF359F801,0xF0FD776E,0xCECC6B56,0x00FFC156,0xB3F17001,0x58AFA76A,0x9A8C7E7C,0x00BCC1F7,0xE2A1D801,0xF0FEA55A,0x9A9856FC,0x01FD80E7,0xC2A3F003,0xA1FFE7CF,0xBF98D4AC,0x01FF801D,0x67E6A006,0xA1554F9F,0x3F30FCF8,0x015F80FF,0xCD63A003,0xE1F54ADD,0xFDB0ADD0,0x03F701FE,0x87C5E007,0x43FFCF95,0xF5E1A958,0x03E607DA,0x8FCD600D,0x42AADF35,0xF561F9F0,0x02B705DF,0x9ACFC007,0xC3EAB59F,0xFFC15BA0,0x03E60ADD,0x1F8BC00E,0x875F9F3F,0xFFC152B0,0x05CE0AB5,0x151EC01A,0x8575BA3B,0xFB83E3E0,0x05601F3F,0x151F801F,0x86976B2B,0xAB82B740,0x07C035BB,0x3F170015,0x8EBF7E6B,0xEB02AD40,0x0A801F6A,0x2A1D8035,0x193B563F,0x3F07C7C0,0x0A803E7E,0x2A2F003F,0x0D2EDC7F,0x7A056E80,0x0F806AD6,0x7E6A002B,0x122CEC7E,0x5A055A80,0x15003EF4,0xD63A006A,0x3666B856,0xD40F8F80,0x350074BC,0xFC5E007E,0x3C6C98DC,0xD41A9D80,0x1F00D7AF,0xFCD60056,0x7C6DA04C,0x680EB500,0x6A00D7AE,0xACFC005E,0xF82DC0F8,0xE81F3F00,0xE380EFDF,0x9F8E03CF,0xF01F80D8,0xD071F300,0xFF0078F3,0xFBFC03FF,0x000E00E0,0x703FFF00,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0x00F358CC,0x19B30000,0,0,0x0049A510,0x24A48000,0,0,0x70493CCC,0x3C478700,0,0,0x00492044,0x20A40000,0,0,0x00739D98,0x1DB38000,0,0,0x00400000,0,0,0,0x00E00000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	unsigned long buffer2[] = {0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0x000FFFE0,0x001FCFC0,0x3FF80000,0,0x000FFFE0,0x001F8FC0,0x3FFE0000,0,0x00066660,0x00198CC0,0x098E0000,0,0x0006C6C0,0x00199D80,0x198E0000,0,0x000CC6C0,0x001B1980,0x1B0F0000,0,0x000DC3C0,0x00331980,0x130F0000,0,0x000D8380,0x00373300,0x331B0000,0,0x00198380,0x00763300,0x361B0000,0,0x001B8380,0x00663700,0x261F0000,0,0x001B0700,0x006C6600,0x66360000,0,0x0033771F,0xE0CC6600,0x6C360F8F,0xEFE7BFFC,0x0037673F,0xF0CC6C00,0xCC363FCF,0xEFE7BFFE,0x00266671,0xB0D8CC00,0xCC667BCE,0xC6C71BF6,0x0066E6F1,0xB198CC00,0xD86CFBCC,0xCCC733A6,0x006CC1F3,0xB198D801,0x986DF3CC,0xCCCE3366,0x004FC1B3,0x31B19801,0x98CDB2CD,0x8D8E366C,0x00CFC1B3,0x63319801,0xB0DB76CD,0x8D9C66CC,0x00CF81E6,0x63733003,0x319B66CD,0x9D9C6CCC,0x009F81C6,0x67633003,0x719E6CD9,0x99B86CD8,0x019F800E,0xC6637003,0x61BEECD9,0xB9B8CD98,0x01B7007C,0xC6C66006,0x633ECD9B,0x3B70D9B8,0x013703FD,0xCCC66006,0xE33CD99B,0x7B70D9B0,0x033707ED,0x8CC6C006,0xC37D999B,0x7BE19B30,0x03660ED9,0x8D8CC00C,0xC67D9B33,0xF3E1B370,0x066E0D9B,0x998CC00D,0xC6F9B333,0xF3C3B360,0x06641D9B,0x1B89800D,0x86DB3737,0xB7C33660,0x06C019B3,0x3B198019,0x8DFB3637,0xB78366E0,0x0CC01B36,0x3319801B,0x0DB36637,0x378766C0,0x0DC03336,0x3733001B,0x0FB66C67,0x67066CC0,0x0D803366,0x76330033,0x1B366C66,0x6706CDC0,0x1980366C,0x66370036,0x1F36D866,0x660ECD80,0x1B8066CC,0x6C660036,0x1E3CD86C,0x6E0CD980,0x1B006FCC,0xCC660066,0x3C3DF06C,0x6C0D9B00,0x33006FDE,0xCC6C006C,0x383DF0F8,0xDC199B00,0x37006FDF,0xD8CC00ED,0xF03FE0D8,0xD819B300,0xFF807EFF,0xFDFC03FF,0xE03FC0F0,0xF83FFF00,0xFF803C7B,0xFDFC03FF,0x801F00F0,0xF03FFF00,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0x00F358CC,0x19B30000,0,0,0x0049A510,0x24A48000,0,0,0x70493CCC,0x3C478700,0,0,0x00492044,0x20A40000,0,0,0x00739D98,0x1DB38000,0,0,0x00400000,0,0,0,0x00E00000,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0};
	GrayLinkBuffers(buffer1, buffer2);
	GrayInit(3273, 1452);
	while(IsKeyDown(KEY_CTRL_EXE));
	while(IsKeyUp(KEY_CTRL_EXE));
	GrayEnd();
}

int gameover(int score)
{
	int i, y=0, dy=0;
	char str[20] = "Score : ";
	int2str(str+8, score);

	while(y!=52 || dy)
	{
		dy++;
		y += dy;
		if(y>52) { y=52; dy=-dy*2/3; }
		Bdisp_AllClr_VRAM();
		CoolText(28, y, FONT_NINE, "Game Over", VRam_Base());
		Bdisp_AreaReverseVRAM(28, y, 99, y+11);
		Bdisp_PutDisp_DD();
		Sleep(30);
	}
	for(y=0 ; y<52 ; y+=3)
	{
		Bdisp_AllClr_VRAM();
		CoolText(28, 52, FONT_NINE, "Game Over", VRam_Base());
		Bdisp_AreaReverseVRAM(28, 52, 99, 63);
		Bdisp_DrawLineVRAM(38, 0, 38, y);
		Bdisp_DrawLineVRAM(89, 0, 89, y);
		Bdisp_PutDisp_DD();
		Sleep(30);
	}
	for(y=0 ; y<36 ; y++)
	{
		Bdisp_AllClr_VRAM();
		CoolText(64-4*strlen(str)/2, 52, FONT_FIVE, str, VRam_Base());
		CoolText(28, 52-y/2, FONT_NINE, "Game Over", VRam_Base());
		Bdisp_AreaReverseVRAM(28, 52-y/2, 99, 63-y/2);
		Bdisp_DrawLineVRAM(38-y, 0, 38, 52-y/2);
		Bdisp_DrawLineVRAM(89+y, 0, 89, 52-y/2);
		Bdisp_PutDisp_DD();
		Sleep(30);
	}
	while(IsKeyUp(KEY_CTRL_EXE))
	{
		if(IsKeyDown(KEY_CTRL_EXIT))
			return 0;
	}
	return 1;
}

int AddIn_main(int isAppli, unsigned short OptionNum)
{
	int score=1;
	titre();
	buffer1 = malloc(1024);
	buffer2 = malloc(1024);
	bufferVRAM1 = malloc(1024);
	bufferVRAM2 = malloc(1024);
	srand(RTCReadSecond()+RTCReadMinute()+RTCReadHour());
	while(score)
	{
		if(score = jeu())
			score = gameover(score);
	}
	free(buffer1);
	free(buffer2);
	free(bufferVRAM1);
	free(bufferVRAM2);
	Reset_Calc();
    return 1;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section
#pragma section _TOP
int InitializeSystem(int isAppli, unsigned short OptionNum)
{
    return INIT_ADDIN_APPLICATION(isAppli, OptionNum);
}
#pragma section
